function allfiltered=backgroundSubtraction(allfiltered, anof)
%anof:  average number of occlusion frames for of background

h = size(allfiltered{1, 1}, 1);
w = size(allfiltered{1, 1}, 2);

nimage = size(allfiltered,1);
norient = size(allfiltered, 2);
bkfiltered = cell(norient, 1);

for ior = 1:norient
    bkfiltered{ior} = zeros([h w]);
    for in=1:nimage
        bkfiltered{ior} = bkfiltered{ior} + allfiltered{in, ior};
    end
    bkfiltered{ior} = bkfiltered{ior}/(nimage-anof);
end

for in=1:nimage
    for ior=1:norient
         allfiltered{in, ior} = allfiltered{in, ior}-bkfiltered{ior};
         idx = find(allfiltered{in, ior}<0.);
         allfiltered{in, ior}(idx) = 0.;
    end
end


